searchNodes=[{"doc":"Adds a compatibility layer for functions which changed either semantics or returns types between Decimal version 1.x and 2.x.","ref":"Cldr.Decimal.html","title":"Cldr.Decimal","type":"module"},{"doc":"","ref":"Cldr.Decimal.html#compare/2","title":"Cldr.Decimal.compare/2","type":"function"},{"doc":"","ref":"Cldr.Decimal.html#parse/1","title":"Cldr.Decimal.parse/1","type":"function"},{"doc":"","ref":"Cldr.Decimal.html#reduce/1","title":"Cldr.Decimal.reduce/1","type":"function"},{"doc":"Abstract representation of number (integer, float, Decimal) in tuple form and functions for transformations on number parts. Representing a number as a list of its digits, and integer representing where the decimal point is placed and an integer representing the sign of the number allow more efficient transforms on the various parts of the number as happens during the formatting of a number for string output.","ref":"Cldr.Digits.html","title":"Cldr.Digits","type":"module"},{"doc":"","ref":"Cldr.Digits.html#fixup/8","title":"Cldr.Digits.fixup/8","type":"function"},{"doc":"Returns the fractional part of an integer, float or Decimal as an integer. number can be either a float, Decimal or integer although an integer has no fraction part and will therefore always return 0. Examples iex&gt; Cldr.Digits . fraction_as_integer ( 123.456 ) 456 iex&gt; Cldr.Digits . fraction_as_integer ( Decimal . new ( &quot;123.456&quot; ) ) 456 iex&gt; Cldr.Digits . fraction_as_integer ( 1999 ) 0","ref":"Cldr.Digits.html#fraction_as_integer/1","title":"Cldr.Digits.fraction_as_integer/1","type":"function"},{"doc":"","ref":"Cldr.Digits.html#fraction_as_integer/2","title":"Cldr.Digits.fraction_as_integer/2","type":"function"},{"doc":"","ref":"Cldr.Digits.html#frexp/3","title":"Cldr.Digits.frexp/3","type":"function"},{"doc":"Returns the number of decimal digits in a number (integer, float, Decimal) Options number is an integer, float or Decimal or a list (which is assumed to contain digits). Examples iex&gt; Cldr.Digits . number_of_digits ( 1234 ) 4 iex&gt; Cldr.Digits . number_of_digits ( Decimal . new ( &quot;123456789&quot; ) ) 9 iex&gt; Cldr.Digits . number_of_digits ( 1234.456 ) 7 iex&gt; Cldr.Digits . number_of_digits ( 1234.56789098765 ) 15 iex&gt; Cldr.Digits . number_of_digits &#39;12345&#39; 5","ref":"Cldr.Digits.html#number_of_digits/1","title":"Cldr.Digits.number_of_digits/1","type":"function"},{"doc":"Returns the number of decimal digits in the integer part of a number. Options number is an integer, float or Decimal or a list (which is assumed to contain digits). Examples iex&gt; Cldr.Digits . number_of_integer_digits ( 1234 ) 4 iex&gt; Cldr.Digits . number_of_integer_digits ( Decimal . new ( &quot;123456789&quot; ) ) 9 iex&gt; Cldr.Digits . number_of_integer_digits ( 1234.456 ) 4 iex&gt; Cldr.Digits . number_of_integer_digits &#39;12345&#39; 5","ref":"Cldr.Digits.html#number_of_integer_digits/1","title":"Cldr.Digits.number_of_integer_digits/1","type":"function"},{"doc":"Returns the number of leading zeros in a Decimal fraction. number is an integer, float or Decimal Returns the number of leading zeros in the fractional part of a number. Examples iex&gt; Cldr.Digits . number_of_leading_zeros ( Decimal . new ( &quot;0.0001&quot; ) ) 3","ref":"Cldr.Digits.html#number_of_leading_zeros/1","title":"Cldr.Digits.number_of_leading_zeros/1","type":"function"},{"doc":"Returns the number of trailing zeros in an integer number. number is an integer. Returns the number of trailing zeros in the fractional part of an integer. Examples iex&gt; Cldr.Digits . number_of_trailing_zeros ( 123000 ) 3","ref":"Cldr.Digits.html#number_of_trailing_zeros/1","title":"Cldr.Digits.number_of_trailing_zeros/1","type":"function"},{"doc":"Remove trailing zeroes from the integer part of a number and returns the integer part without trailing zeros. number is an integer, float or Decimal. Examples iex&gt; Cldr.Digits . remove_trailing_zeros ( 1234000 ) 1234","ref":"Cldr.Digits.html#remove_trailing_zeros/1","title":"Cldr.Digits.remove_trailing_zeros/1","type":"function"},{"doc":"","ref":"Cldr.Digits.html#scale/7","title":"Cldr.Digits.scale/7","type":"function"},{"doc":"","ref":"Cldr.Digits.html#to_decimal/1","title":"Cldr.Digits.to_decimal/1","type":"function"},{"doc":"Computes a iodata list of the digits of the given IEEE 754 floating point number, together with the location of the decimal point as {digits, place, positive}. A &quot;compact&quot; representation is returned, so there may be fewer digits returned than the decimal point location.","ref":"Cldr.Digits.html#to_digits/1","title":"Cldr.Digits.to_digits/1","type":"function"},{"doc":"","ref":"Cldr.Digits.html#to_float/1","title":"Cldr.Digits.to_float/1","type":"function"},{"doc":"","ref":"Cldr.Digits.html#to_integer/1","title":"Cldr.Digits.to_integer/1","type":"function"},{"doc":"Takes a list of digits and coverts them back to a number of the same type as number .","ref":"Cldr.Digits.html#to_number/2","title":"Cldr.Digits.to_number/2","type":"function"},{"doc":"Converts given number to a list representation. Given an IEEE 754 float, computes the shortest, correctly rounded list of digits that converts back to the same Double value when read back with String.to_float/1. Implements the algorithm from &quot;Printing Floating-Point Numbers Quickly and Accurately&quot; in Proceedings of the SIGPLAN '96 Conference on Programming Language Design and Implementation. Returns a tuple comprising a charlist for the integer part, a charlist for the fractional part and an integer for the sign.","ref":"Cldr.Digits.html#to_tuple/1","title":"Cldr.Digits.to_tuple/1","type":"function"},{"doc":"Defines a number in a tuple form of three parts: A list of digits (0..9) representing the number A digit representing the place of the decimal points in the number a 1 or -1 representing the sign of the number A number in integer, float or Decimal form can be converted to digit form with Digits.to_digits/1 . The digits can be converted back to normal form with Cldr.Digits.to_integer/1 , Cldr.Digits.to_float/1 and Cldr.Digits.to_decimal/1 .","ref":"Cldr.Digits.html#t:t/0","title":"Cldr.Digits.t/0","type":"type"},{"doc":"","ref":"Cldr.Enum.html","title":"Cldr.Enum","type":"module"},{"doc":"","ref":"Cldr.Enum.html#combine_list/1","title":"Cldr.Enum.combine_list/1","type":"function"},{"doc":"Very simple reduce that passes both the head and the tail to the reducing function so it has some lookahead.","ref":"Cldr.Enum.html#reduce_peeking/3","title":"Cldr.Enum.reduce_peeking/3","type":"function"},{"doc":"General purpose helper functions for CLDR","ref":"Cldr.Helpers.html","title":"Cldr.Helpers","type":"module"},{"doc":"Returns a boolean indicating if a data structure is semanically empty. Applies to lists, maps and nil","ref":"Cldr.Helpers.html#empty?/1","title":"Cldr.Helpers.empty?/1","type":"function"},{"doc":"Supports securely downloading https content.","ref":"Cldr.Http.html","title":"Cldr.Http","type":"module"},{"doc":"Securely download https content from a URL. This function uses the built-in :httpc client but enables certificate verification which is not enabled by :httc by default. See also https://erlef.github.io/security-wg/secure_coding_and_deployment_hardening/ssl Arguments url is a binary URL or a {url, list_of_headers} tuple. If provided the headers are a list of {'header_name', 'header_value'} tuples. Note that the name and value are both charlists, not strings. options is a keyword list of options. Options :verify_peer is a boolean value indicating if peer verification should be done for this request. The default is true in which case the default :ssl options follow the erlef guidelines noted above. :timeout is the number of milliseconds available for the request to complete. The default is &quot;120000&quot;. This option may also be set with the CLDR_HTTP_TIMEOUT environment variable. :connection_timeout is the number of milliseconds available for the a connection to be estabklished to the remote host. The default is &quot;60000&quot;. This option may also be set with the CLDR_HTTP_CONNECTION_TIMEOUT environment variable. Returns {:ok, body} if the return is successful. {:not_modified, headers} if the request would result in returning the same results as one matching an etag. {:error, error} if the download is unsuccessful. An error will also be logged in these cases. Unsafe HTTPS If the environment variable CLDR_UNSAFE_HTTPS is set to anything other than FALSE , false , nil or NIL then no peer verification of certificates is performed. Setting this variable is not recommended but may be required is where peer verification for unidentified reasons. Please open an issue if this occurs. Certificate stores In order to keep dependencies to a minimum, get/1 attempts to locate an already installed certificate store. It will try to locate a store in the following order which is intended to satisfy most host systems. The certificate store is expected to be a path name on the host system. # A certificate store configured by the # developer Application . get_env ( :ex_cldr , :cacertfile ) # Populated if hex package `CAStore` is configured CAStore . file_path ( ) # Populated if hex package `certfi` is configured :certifi . cacertfile ( ) # Debian/Ubuntu/Gentoo etc. &quot;/etc/ssl/certs/ca-certificates.crt&quot; , # Fedora/RHEL 6 &quot;/etc/pki/tls/certs/ca-bundle.crt&quot; , # OpenSUSE &quot;/etc/ssl/ca-bundle.pem&quot; , # OpenELEC &quot;/etc/pki/tls/cacert.pem&quot; , # CentOS/RHEL 7 &quot;/etc/pki/ca-trust/extracted/pem/tls-ca-bundle.pem&quot; , # Open SSL on MacOS &quot;/usr/local/etc/openssl/cert.pem&quot; , # MacOS &amp; Alpine Linux &quot;/etc/ssl/cert.pem&quot;","ref":"Cldr.Http.html#get/2","title":"Cldr.Http.get/2","type":"function"},{"doc":"Securely download https content from a URL. This function uses the built-in :httpc client but enables certificate verification which is not enabled by :httc by default. See also https://erlef.github.io/security-wg/secure_coding_and_deployment_hardening/ssl Arguments url is a binary URL or a {url, list_of_headers} tuple. If provided the headers are a list of {'header_name', 'header_value'} tuples. Note that the name and value are both charlists, not strings. options is a keyword list of options. Options :verify_peer is a boolean value indicating if peer verification should be done for this request. The default is true in which case the default :ssl options follow the erlef guidelines noted above. :timeout is the number of milliseconds available for the request to complete. The default is &quot;120000&quot;. This option may also be set with the CLDR_HTTP_TIMEOUT environment variable. :connection_timeout is the number of milliseconds available for the a connection to be estabklished to the remote host. The default is &quot;60000&quot;. This option may also be set with the CLDR_HTTP_CONNECTION_TIMEOUT environment variable. Returns {:ok, body, headers} if the return is successful. {:not_modified, headers} if the request would result in returning the same results as one matching an etag. {:error, error} if the download is unsuccessful. An error will also be logged in these cases. Unsafe HTTPS If the environment variable CLDR_UNSAFE_HTTPS is set to anything other than FALSE , false , nil or NIL then no peer verification of certificates is performed. Setting this variable is not recommended but may be required is where peer verification for unidentified reasons. Please open an issue if this occurs. Certificate stores In order to keep dependencies to a minimum, get/1 attempts to locate an already installed certificate store. It will try to locate a store in the following order which is intended to satisfy most host systems. The certificate store is expected to be a path name on the host system. # A certificate store configured by the # developer Application . get_env ( :ex_cldr , :cacertfile ) # Populated if hex package `CAStore` is configured CAStore . file_path ( ) # Populated if hex package `certfi` is configured :certifi . cacertfile ( ) # Debian/Ubuntu/Gentoo etc. &quot;/etc/ssl/certs/ca-certificates.crt&quot; , # Fedora/RHEL 6 &quot;/etc/pki/tls/certs/ca-bundle.crt&quot; , # OpenSUSE &quot;/etc/ssl/ca-bundle.pem&quot; , # OpenELEC &quot;/etc/pki/tls/cacert.pem&quot; , # CentOS/RHEL 7 &quot;/etc/pki/ca-trust/extracted/pem/tls-ca-bundle.pem&quot; , # Open SSL on MacOS &quot;/usr/local/etc/openssl/cert.pem&quot; , # MacOS &amp; Alpine Linux &quot;/etc/ssl/cert.pem&quot;","ref":"Cldr.Http.html#get_with_headers/2","title":"Cldr.Http.get_with_headers/2","type":"function"},{"doc":"","ref":"Cldr.Http.html#http_opts/2","title":"Cldr.Http.http_opts/2","type":"function"},{"doc":"","ref":"Cldr.Http.html#otp_version/0","title":"Cldr.Http.otp_version/0","type":"function"},{"doc":"","ref":"Cldr.Http.html#preferred_ciphers/0","title":"Cldr.Http.preferred_ciphers/0","type":"function"},{"doc":"","ref":"Cldr.Http.html#preferred_eccs/0","title":"Cldr.Http.preferred_eccs/0","type":"function"},{"doc":"","ref":"Cldr.Http.html#protocol_versions/0","title":"Cldr.Http.protocol_versions/0","type":"function"},{"doc":"","ref":"Cldr.Http.html#secure_ssl?/0","title":"Cldr.Http.secure_ssl?/0","type":"function"},{"doc":"Functions for transforming maps, keys and values.","ref":"Cldr.Map.html","title":"Cldr.Map","type":"module"},{"doc":"Transforms a map 's String.t keys to atom() keys. Arguments map is any map/0 options is a keyword list of options passed to deep_map/3 . One additional option apples to this function directly: :only_existing which is set to true will only convert the binary value to an atom if the atom already exists. The default is false . Example iex&gt; Cldr.Map . atomize_keys %{ &quot;a&quot; =&gt; %{ &quot;b&quot; =&gt; %{ 1 =&gt; &quot;c&quot; } } } %{ a : %{ b : %{ 1 =&gt; &quot;c&quot; } } }","ref":"Cldr.Map.html#atomize_keys/2","title":"Cldr.Map.atomize_keys/2","type":"function"},{"doc":"Transforms a map 's String.t values to atom() values. Arguments map is any map/0 options is a keyword list of options passed to deep_map/3 . One additional option apples to this function directly: :only_existing which is set to true will only convert the binary value to an atom if the atom already exists. The default is false . Examples iex&gt; Cldr.Map . atomize_values %{ &quot;a&quot; =&gt; %{ &quot;b&quot; =&gt; %{ 1 =&gt; &quot;c&quot; } } } %{ &quot;a&quot; =&gt; %{ &quot;b&quot; =&gt; %{ 1 =&gt; :c } } }","ref":"Cldr.Map.html#atomize_values/2","title":"Cldr.Map.atomize_values/2","type":"function"},{"doc":"","ref":"Cldr.Map.html#combine_list_resolver/3","title":"Cldr.Map.combine_list_resolver/3","type":"function"},{"doc":"Recursively traverse a map and invoke a function that transforms the mapfor each key/value pair. Arguments map is any map/0 function is a 1-arity function or function reference that is called for each key/value pair of the provided map. It can also be a 2-tuple of the form {key_function, value_function} In the case where function is a single function it will be called with the 2-tuple argument {key, value} In the case where function is of the form {key_function, value_function} the key_function will be called with the argument key and the value function will be called with the argument value options is a keyword list of options. The default is [level: 1..1000000, filter: [], reject: [], skip: [], only: [], except: []] Options :level indicates the starting (and optionally ending) levels of the map at which the function is executed. This can be an integer representing one level or a range indicating a range of levels. The default is 1..1000000 :only is a term or list of terms or a check function . If it is a term or list of terms, the function is only called if the key of the map is equal to the term or in the list of terms. If :only is a check function then the check function is passed the {k, v} of the current branch in the map . It is expected to return a truthy value that if true signals that the argument function will be executed. :except is a term or list of terms or a check function . If it is a term or list of terms, the function is only called if the key of the map is not equal to the term or not in the list of terms. If :except is a check function then the check function is passed the {k, v} of the current branch in the map . It is expected to return a truthy value that if true signals that the argument function will not be executed. :filter is a term or list of terms or a check function . If the key currently being processed equals the term (or is in the list of terms, or the check_function returns a truthy value) then this branch of the map is processed by function and its output is included in the result. :reject is a term or list of terms or a check function . If the key currently being processed equals the term (or is in the list of terms, or the check_function returns a truthy value) then this branch of the map is omitted from the mapped output. :skip is a term or list of terms or a check function . If the key currently being processed equals the term (or is in the list of terms, or the check_function returns a truthy value) then this branch of the map is not processed by function but it is included in the mapped result. Notes :only and :except operate on individual keys whereas :filter and :filter and :reject operator on entire branches of a map If both the options :only and :except are provided then the function is called only when a term meets both criteria. That means that :except has priority over :only . If both the options :filter and :reject are provided then :reject has priority over :filter . Returns The map transformed by the recursive application of function Examples iex&gt; map = %{ a : :a , b : %{ c : :c } } iex&gt; fun = fn ...&gt; { k , v } when is_atom ( k ) -&gt; { Atom . to_string ( k ) , v } ...&gt; other -&gt; other ...&gt; end iex&gt; Cldr.Map . deep_map map , fun %{ &quot;a&quot; =&gt; :a , &quot;b&quot; =&gt; %{ &quot;c&quot; =&gt; :c } } iex&gt; map = %{ a : :a , b : %{ c : :c } } iex&gt; Cldr.Map . deep_map map , fun , only : :c %{ a : :a , b : %{ &quot;c&quot; =&gt; :c } } iex&gt; Cldr.Map . deep_map map , fun , except : [ :a , :b ] %{ a : :a , b : %{ &quot;c&quot; =&gt; :c } } iex&gt; Cldr.Map . deep_map map , fun , level : 2 %{ a : :a , b : %{ &quot;c&quot; =&gt; :c } }","ref":"Cldr.Map.html#deep_map/3","title":"Cldr.Map.deep_map/3","type":"function"},{"doc":"Deep merge two maps left is any map/0 right is any map/0 Examples iex&gt; Cldr.Map . deep_merge %{ a : &quot;a&quot; , b : &quot;b&quot; } , %{ c : &quot;c&quot; , d : &quot;d&quot; } %{ a : &quot;a&quot; , b : &quot;b&quot; , c : &quot;c&quot; , d : &quot;d&quot; } iex&gt; Cldr.Map . deep_merge %{ a : &quot;a&quot; , b : &quot;b&quot; } , %{ c : &quot;c&quot; , d : &quot;d&quot; , a : &quot;aa&quot; } %{ a : &quot;aa&quot; , b : &quot;b&quot; , c : &quot;c&quot; , d : &quot;d&quot; }","ref":"Cldr.Map.html#deep_merge/3","title":"Cldr.Map.deep_merge/3","type":"function"},{"doc":"Delete all members of a map that have a key in the list of keys Examples iex&gt; Cldr.Map . delete_in %{ a : &quot;a&quot; , b : &quot;b&quot; } , [ :a ] %{ b : &quot;b&quot; }","ref":"Cldr.Map.html#delete_in/2","title":"Cldr.Map.delete_in/2","type":"function"},{"doc":"Extract strings from a map or list Recursively process the map or list and extract string values from maps and string elements from lists","ref":"Cldr.Map.html#extract_strings/2","title":"Cldr.Map.extract_strings/2","type":"function"},{"doc":"Transforms a map 's String.t keys to Float.t values. Arguments map is any map/0 options is a keyword list of options passed to deep_map/3 The map key is converted to a float from a String.t only when the key is comprised of a valid float form. Keys which cannot be converted to a float are returned unchanged. Examples iex&gt; Cldr.Map . floatize_keys %{ a : %{ &quot;1.0&quot; =&gt; &quot;value&quot; } } %{ a : %{ 1.0 =&gt; &quot;value&quot; } } iex&gt; Cldr.Map . floatize_keys %{ a : %{ &quot;1&quot; =&gt; &quot;value&quot; } } %{ a : %{ 1.0 =&gt; &quot;value&quot; } }","ref":"Cldr.Map.html#floatize_keys/2","title":"Cldr.Map.floatize_keys/2","type":"function"},{"doc":"Transforms a map 's String.t values to Float.t values. Arguments map is any map/0 options is a keyword list of options passed to deep_map/3 The map value is converted to a float from a String.t only when the value is comprised of a valid float form. Values which cannot be converted to a float are returned unchanged. Examples iex&gt; Cldr.Map . floatize_values %{ a : %{ b : &quot;1.0&quot; } } %{ a : %{ b : 1.0 } } iex&gt; Cldr.Map . floatize_values %{ a : %{ b : &quot;1&quot; } } %{ a : %{ b : 1.0 } }","ref":"Cldr.Map.html#floatize_values/2","title":"Cldr.Map.floatize_values/2","type":"function"},{"doc":"","ref":"Cldr.Map.html#from_keyword/1","title":"Cldr.Map.from_keyword/1","type":"function"},{"doc":"Returns am argument unchanged. Useful when a noop function is required.","ref":"Cldr.Map.html#identity/1","title":"Cldr.Map.identity/1","type":"function"},{"doc":"Transforms a map 's String.t keys to Integer.t keys. Arguments map is any map/0 options is a keyword list of options passed to deep_map/3 The map key is converted to an integer from either an atom or String.t only when the key is comprised of integer digits. Keys which cannot be converted to an integer are returned unchanged. Example iex&gt; Cldr.Map . integerize_keys %{ a : %{ &quot;1&quot; =&gt; &quot;value&quot; } } %{ a : %{ 1 =&gt; &quot;value&quot; } }","ref":"Cldr.Map.html#integerize_keys/2","title":"Cldr.Map.integerize_keys/2","type":"function"},{"doc":"Transforms a map 's String.t values to Integer.t values. Arguments map is any map/0 options is a keyword list of options passed to deep_map/3 The map value is converted to an integer from either an atom or String.t only when the value is comprised of integer digits. Keys which cannot be converted to an integer are returned unchanged. Example iex&gt; Cldr.Map . integerize_values %{ a : %{ b : &quot;1&quot; } } %{ a : %{ b : 1 } }","ref":"Cldr.Map.html#integerize_values/2","title":"Cldr.Map.integerize_values/2","type":"function"},{"doc":"Invert a map Requires that the map is a simple map of keys and a list of values or a single non-map value Options :duplicates which determines how duplicate values are handled: nil or false which is the default and means only one value is kept. Map.new/1 is used meanng the selected value is non-deterministic. :keep meaning duplicate values are returned in a list :shortest means the shortest duplicate is kept. This operates on string or atom values. :longest means the shortest duplicate is kept. This operates on string or atom values.","ref":"Cldr.Map.html#invert/2","title":"Cldr.Map.invert/2","type":"function"},{"doc":"Returns the result of deep merging a list of maps Examples iex&gt; Cldr.Map . merge_map_list [ %{ a : &quot;a&quot; , b : &quot;b&quot; } , %{ c : &quot;c&quot; , d : &quot;d&quot; } ] %{ a : &quot;a&quot; , b : &quot;b&quot; , c : &quot;c&quot; , d : &quot;d&quot; }","ref":"Cldr.Map.html#merge_map_list/2","title":"Cldr.Map.merge_map_list/2","type":"function"},{"doc":"","ref":"Cldr.Map.html#process_type/2","title":"Cldr.Map.process_type/2","type":"function"},{"doc":"Prune a potentially deeply nested map of some of its branches","ref":"Cldr.Map.html#prune/2","title":"Cldr.Map.prune/2","type":"function"},{"doc":"Removes any leading underscores from map String.t keys. map is any map/0 options is a keyword list of options passed to deep_map/3 Examples iex&gt; Cldr.Map . remove_leading_underscores %{ &quot;a&quot; =&gt; %{ &quot;_b&quot; =&gt; &quot;b&quot; } } %{ &quot;a&quot; =&gt; %{ &quot;b&quot; =&gt; &quot;b&quot; } }","ref":"Cldr.Map.html#remove_leading_underscores/2","title":"Cldr.Map.remove_leading_underscores/2","type":"function"},{"doc":"Rename map keys from from to to map is any map/0 from is any value map key to is any valid map key options is a keyword list of options passed to deep_map/3 Example iex&gt; Cldr.Map . rename_keys %{ &quot;a&quot; =&gt; %{ &quot;this_one&quot; =&gt; &quot;value&quot; } } , &quot;this_one&quot; , &quot;that_one&quot; %{ &quot;a&quot; =&gt; %{ &quot;that_one&quot; =&gt; &quot;value&quot; } }","ref":"Cldr.Map.html#rename_keys/4","title":"Cldr.Map.rename_keys/4","type":"function"},{"doc":"Transforms a map 's atom() keys to String.t keys. Arguments map is any map/0 options is a keyword list of options passed to deep_map/3 Example iex&gt; Cldr.Map . stringify_keys %{ a : %{ &quot;1&quot; =&gt; &quot;value&quot; } } %{ &quot;a&quot; =&gt; %{ &quot;1&quot; =&gt; &quot;value&quot; } }","ref":"Cldr.Map.html#stringify_keys/2","title":"Cldr.Map.stringify_keys/2","type":"function"},{"doc":"Transforms a map 's atom() keys to String.t keys. Arguments map is any map/0 options is a keyword list of options passed to deep_map/3 Example iex&gt; Cldr.Map . stringify_values %{ a : %{ &quot;1&quot; =&gt; :value } } %{ a : %{ &quot;1&quot; =&gt; &quot;value&quot; } }","ref":"Cldr.Map.html#stringify_values/2","title":"Cldr.Map.stringify_values/2","type":"function"},{"doc":"Convert a camelCase string or atom to a snake_case string is a String.t or atom() to be transformed This is the code of Macro.underscore with modifications. The change is to cater for strings in the format: This_That which in Macro.underscore gets formatted as this__that (note the double underscore) when we actually want that_that Examples iex&gt; Cldr.Map . underscore &quot;thisThat&quot; &quot;this_that&quot; iex&gt; Cldr.Map . underscore &quot;This_That&quot; &quot;this_that&quot;","ref":"Cldr.Map.html#underscore/1","title":"Cldr.Map.underscore/1","type":"function"},{"doc":"Convert map String.t keys from camelCase to snake_case map is any map/0 options is a keyword list of options passed to deep_map/3 Example iex&gt; Cldr.Map . underscore_keys %{ &quot;a&quot; =&gt; %{ &quot;thisOne&quot; =&gt; &quot;value&quot; } } %{ &quot;a&quot; =&gt; %{ &quot;this_one&quot; =&gt; &quot;value&quot; } }","ref":"Cldr.Map.html#underscore_keys/2","title":"Cldr.Map.underscore_keys/2","type":"function"},{"doc":"Math helper functions for number formatting.","ref":"Cldr.Math.html","title":"Cldr.Math","type":"module"},{"doc":"Returns the adjusted modulus of x and y .","ref":"Cldr.Math.html#amod/2","title":"Cldr.Math.amod/2","type":"function"},{"doc":"Returns a tuple representing a number in a normalized form with the mantissa in the range 0 &lt; m &lt; 10 and a base 10 exponent. number is an integer, float or Decimal Examples Cldr.Math . coef_exponent ( Decimal . new ( 1.23004 ) ) { # Decimal &lt; 1.23004 &gt; , 0 } Cldr.Math . coef_exponent ( Decimal . new ( 465 ) ) { # Decimal &lt; 4.65 &gt; , 2 } Cldr.Math . coef_exponent ( Decimal . new ( - 46.543 ) ) { # Decimal &lt; - 4.6543 &gt; , 1 }","ref":"Cldr.Math.html#coef_exponent/1","title":"Cldr.Math.coef_exponent/1","type":"function"},{"doc":"Returns a tuple representing a number in a normalized form with the mantissa in the range 0 &lt; m &lt; 10 and a base 10 exponent. The mantissa is represented as tuple of the form Digits.t . number is an integer, float or Decimal Examples Cldr.Math . coef_exponent_digits ( Decimal . new ( 1.23004 ) ) { { [ 1 , 2 , 3 , 0 ] , 1 , 1 } , 0 } Cldr.Math . coef_exponent_digits ( Decimal . new ( 465 ) ) { { [ 4 , 6 , 5 ] , 1 , 1 } , - 1 } Cldr.Math . coef_exponent_digits ( Decimal . new ( - 46.543 ) ) { { [ 4 , 6 , 5 , 4 ] , 1 , - 1 } , 1 }","ref":"Cldr.Math.html#coef_exponent_digits/1","title":"Cldr.Math.coef_exponent_digits/1","type":"function"},{"doc":"Returns the default number of rounding digits.","ref":"Cldr.Math.html#default_rounding/0","title":"Cldr.Math.default_rounding/0","type":"function"},{"doc":"Returns the default rounding mode for rounding operations.","ref":"Cldr.Math.html#default_rounding_mode/0","title":"Cldr.Math.default_rounding_mode/0","type":"function"},{"doc":"Returns the adjusted remainder and dividend of two integers. This version will return the divisor if the remainder would otherwise be zero.","ref":"Cldr.Math.html#div_amod/2","title":"Cldr.Math.div_amod/2","type":"function"},{"doc":"Returns the remainder and dividend of two integers.","ref":"Cldr.Math.html#div_mod/2","title":"Cldr.Math.div_mod/2","type":"function"},{"doc":"Return the natural log of a number. number is an integer, a float or a Decimal For integer and float it calls the BIF :math.log10/1 function. For Decimal the log is rolled by hand. Examples iex&gt; Cldr.Math . log ( 123 ) 4.812184355372417 iex&gt; Cldr.Math . log ( Decimal . new ( 9000 ) ) # Decimal &lt; 9.103886231350952380952380952 &gt;","ref":"Cldr.Math.html#log/1","title":"Cldr.Math.log/1","type":"function"},{"doc":"Return the log10 of a number. number is an integer, a float or a Decimal For integer and float it calls the BIF :math.log10/1 function. For Decimal , log10 is is rolled by hand using the identify log10(x) = ln(x) / ln(10) Examples iex&gt; Cldr.Math . log10 ( 100 ) 2.0 iex&gt; Cldr.Math . log10 ( 123 ) 2.089905111439398 iex&gt; Cldr.Math . log10 ( Decimal . new ( 9000 ) ) # Decimal &lt; 3.953767554157656512064441441 &gt;","ref":"Cldr.Math.html#log10/1","title":"Cldr.Math.log10/1","type":"function"},{"doc":"Calculates the modulo of a number (integer, float or Decimal). Note that this function uses floored division whereas the builtin rem function uses truncated division . See Decimal.rem/2 if you want a truncated division function for Decimals that will return the same value as the BIF rem/2 but in Decimal form. See Wikipedia for an explanation of the difference. Examples iex&gt; Cldr.Math . mod ( 1234.0 , 5 ) 4.0 iex&gt; Cldr.Math . mod ( Decimal . new ( &quot;1234.456&quot; ) , 5 ) # Decimal &lt; 4.456 &gt; iex&gt; Cldr.Math . mod ( Decimal . new ( &quot;123.456&quot; ) , Decimal . new ( &quot;3.4&quot; ) ) # Decimal &lt; 1.056 &gt; iex&gt; Cldr.Math . mod Decimal . new ( &quot;123.456&quot; ) , 3.4 # Decimal &lt; 1.056 &gt;","ref":"Cldr.Math.html#mod/2","title":"Cldr.Math.mod/2","type":"function"},{"doc":"Raises a number to a integer power. Raises a number to a power using the the binary method. There is one exception for Decimal numbers that raise 10 to some power. In this case the power is calculated by shifting the Decimal exponent which is quite efficient. For further reading see this article This function works only with integer exponents! Examples iex&gt; Cldr.Math . power ( 10 , 2 ) 100 iex&gt; Cldr.Math . power ( 10 , 3 ) 1000 iex&gt; Cldr.Math . power ( 10 , 4 ) 10000 iex&gt; Cldr.Math . power ( 2 , 10 ) 1024","ref":"Cldr.Math.html#power/2","title":"Cldr.Math.power/2","type":"function"},{"doc":"Calculate the nth root of a number. number is an integer or a Decimal nth is a positive integer Examples iex&gt; Cldr.Math . root Decimal . new ( 8 ) , 3 # Decimal &lt; 2.0 &gt; iex&gt; Cldr.Math . root Decimal . new ( 16 ) , 4 # Decimal &lt; 2.0 &gt; iex&gt; Cldr.Math . root Decimal . new ( 27 ) , 3 # Decimal &lt; 3.0 &gt;","ref":"Cldr.Math.html#root/2","title":"Cldr.Math.root/2","type":"function"},{"doc":"Round a number to an arbitrary precision using one of several rounding algorithms. Rounding algorithms are based on the definitions given in IEEE 754, but also include 2 additional options (effectively the complementary versions): Arguments number is a float , integer or Decimal places is an integer number of places to round to mode is the rounding mode to be applied. The default is :half_even Rounding algorithms Directed roundings: :down - Round towards 0 (truncate), eg 10.9 rounds to 10.0 :up - Round away from 0, eg 10.1 rounds to 11.0. (Non IEEE algorithm) :ceiling - Round toward +∞ - Also known as rounding up or ceiling :floor - Round toward -∞ - Also known as rounding down or floor Round to nearest: :half_even - Round to nearest value, but in a tiebreak, round towards the nearest value with an even (zero) least significant bit, which occurs 50% of the time. This is the default for IEEE binary floating-point and the recommended value for decimal. :half_up - Round to nearest value, but in a tiebreak, round away from 0. This is the default algorithm for Erlang's Kernel.round/2 :half_down - Round to nearest value, but in a tiebreak, round towards 0 (Non IEEE algorithm) Notes When the number is a Decimal , the results are identical to Decimal.round/3 (delegates to Decimal in these cases) When the number is a float , places is 0 and mode is :half_up then the result is the same as Kernel.trunc/1 The results of rounding for floats may not return the same result as Float.round/2 . Float.round/2 operates on the binary representation. This implementation operates on a decimal representation.","ref":"Cldr.Math.html#round/3","title":"Cldr.Math.round/3","type":"function"},{"doc":"Rounds a number to a specified number of significant digits. This is not the same as rounding fractional digits which is performed by Decimal.round/2 and Float.round number is a float, integer or Decimal n is the number of significant digits to which the number should be rounded Examples iex&gt; Cldr.Math . round_significant ( 3.14159 , 3 ) 3.14 iex&gt; Cldr.Math . round_significant ( 10.3554 , 1 ) 10.0 iex&gt; Cldr.Math . round_significant ( 0.00035 , 1 ) 0.0004 iex&gt; Cldr.Math . round_significant ( Decimal . from_float ( 3.342742283480345e27 ) , 7 ) # Decimal &lt; 3.342742 E + 27 &gt; Notes about precision Since floats cannot accurately represent all decimal numbers, so rounding to significant digits for a float cannot always return the expected results. For example: =&gt; Cldr.Math . round_significant ( 3.342742283480345e27 , 7 ) Expected result : 3.342742e27 Actual result : 3.3427420000000003e27 Use of Decimal numbers avoids this issue: =&gt; Cldr.Math . round_significant ( Decimal . from_float ( 3.342742283480345e27 ) , 7 ) Expected result : # Decimal &lt; 3.342742 E + 27 &gt; Actual result : # Decimal &lt; 3.342742 E + 27 &gt; More on significant digits 3.14159 has six significant digits (all the numbers give you useful information) 1000 has one significant digit (only the 1 is interesting; you don't know anything for sure about the hundreds, tens, or units places; the zeroes may just be placeholders; they may have rounded something off to get this value) 1000.0 has five significant digits (the &quot;.0&quot; tells us something interesting about the presumed accuracy of the measurement being made: that the measurement is accurate to the tenths place, but that there happen to be zero tenths) 0.00035 has two significant digits (only the 3 and 5 tell us something; the other zeroes are placeholders, only providing information about relative size) 0.000350 has three significant digits (that last zero tells us that the measurement was made accurate to that last digit, which just happened to have a value of zero) 1006 has four significant digits (the 1 and 6 are interesting, and we have to count the zeroes, because they're between the two interesting numbers) 560 has two significant digits (the last zero is just a placeholder) 560.0 has four significant digits (the zero in the tenths place means that the measurement was made accurate to the tenths place, and that there just happen to be zero tenths; the 5 and 6 give useful information, and the other zero is between significant digits, and must therefore also be counted) Many thanks to Stackoverflow","ref":"Cldr.Math.html#round_significant/2","title":"Cldr.Math.round_significant/2","type":"function"},{"doc":"Calculates the square root of a Decimal number using Newton's method. number is an integer, float or Decimal. For integer and float, sqrt is delegated to the erlang :math module. We convert the Decimal to a float and take its :math.sqrt only to get an initial estimate. The means typically we are only two iterations from a solution so the slight hack improves performance without sacrificing precision. Examples iex&gt; Cldr.Math . sqrt ( Decimal . new ( 9 ) ) # Decimal &lt; 3.0 &gt; iex&gt; Cldr.Math . sqrt ( Decimal . new ( &quot;9.869&quot; ) ) # Decimal &lt; 3.141496458696078173887197038 &gt;","ref":"Cldr.Math.html#sqrt/2","title":"Cldr.Math.sqrt/2","type":"function"},{"doc":"Convert a Decimal to a float decimal must be a Decimal This is very likely to lose precision - lots of numbers won't make the round trip conversion. Use with care. Actually, better not to use it at all.","ref":"Cldr.Math.html#to_float/1","title":"Cldr.Math.to_float/1","type":"function"},{"doc":"Check if a number is within a range . number is either an integer or a float. When an integer, the comparison is made using the standard Elixir in operator. When number is a float the comparison is made using the &gt;= and &lt;= operators on the range endpoints. Note the comparison for a float is only for floats that have no fractional part. If a float has a fractional part then within returns false . Since this function is only provided to support plural rules, the float comparison is only useful if the float has no fractional part. Examples iex&gt; Cldr.Math . within ( 2.0 , 1 .. 3 ) true iex&gt; Cldr.Math . within ( 2.1 , 1 .. 3 ) false","ref":"Cldr.Math.html#within/2","title":"Cldr.Math.within/2","type":"function"},{"doc":"","ref":"Cldr.Math.html#t:normalised_decimal/0","title":"Cldr.Math.normalised_decimal/0","type":"type"},{"doc":"","ref":"Cldr.Math.html#t:number_or_decimal/0","title":"Cldr.Math.number_or_decimal/0","type":"type"},{"doc":"","ref":"Cldr.Math.html#t:rounding/0","title":"Cldr.Math.rounding/0","type":"type"},{"doc":"Functions that operate on a String.t that are not provided in the standard lib.","ref":"Cldr.String.html","title":"Cldr.String","type":"module"},{"doc":"Hash a string using a polynomial rolling hash function. See https://cp-algorithms.com/string/string-hashing.html for a description of the algoithim.","ref":"Cldr.String.html#hash/1","title":"Cldr.String.hash/1","type":"function"},{"doc":"","ref":"Cldr.String.html#to_lower_char/1","title":"Cldr.String.to_lower_char/1","type":"function"},{"doc":"Replaces &quot;-&quot; with &quot;_&quot; in a string. Examples iex&gt; Cldr.String . to_underscore ( &quot;this-one&quot; ) &quot;this_one&quot;","ref":"Cldr.String.html#to_underscore/1","title":"Cldr.String.to_underscore/1","type":"function"},{"doc":"","ref":"Cldr.String.html#to_upper_char/1","title":"Cldr.String.to_upper_char/1","type":"function"},{"doc":"This is the code of Macro.underscore with modifications: The change is to cater for strings in the format: This_That which in Macro.underscore gets formatted as: this__that ( note the double underscore ) when we actually want: that_that","ref":"Cldr.String.html#underscore/1","title":"Cldr.String.underscore/1","type":"function"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.22.0 released on March 25th, 2023. For older changelogs please consult the release tag on GitHub Cldr Utils now requires Elixir 1.11 or later Enhancements Adds :timeout and :connection_timeout options to Cldr.Http.get/2 . The defaults are [timeout: 60_000, connection_timeout: 120_000] . The environment variables CLDR_HTTP_TIMEOUT and CLDR_HTTPS_CONNECTION_TIMEOUT can also be used to set the timeouts. The prededence is options[:timeout] -&gt; environment variable -&gt; default.","ref":"changelog.html#cldr-utils-version-2-22-0","title":"Changelog - Cldr Utils version 2.22.0","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.21.0 released on January 27th, 2023. For older changelogs please consult the release tag on GitHub Cldr Utils now requires Elixir 1.11 or later Enhancements Add :verify_peer as an option to Cldr.Http.get/1 and Cldr.Http.get_with_headers/1","ref":"changelog.html#cldr-utils-version-2-21-0","title":"Changelog - Cldr Utils version 2.21.0","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.20.0 released on January 27th, 2023. For older changelogs please consult the release tag on GitHub Cldr Utils now requires Elixir 1.11 or later Enhancements Adds Cldr.Http.get_with_headers/1 that will return the headers from the response as well as the body. Support headers when sending a request with Cldr.Http.get/1 and Cldr.Http.get_with_headers/1 Add :verify_peer as an option to Cldr.Http.get/1 and Cldr.Http.get_with_headers/1","ref":"changelog.html#cldr-utils-version-2-20-0","title":"Changelog - Cldr Utils version 2.20.0","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.19.2 released on January 25th, 2023. For older changelogs please consult the release tag on GitHub Cldr Utils now requires Elixir 1.11 or later Bug Fixes Relaxes the requirement for the optional castore library. Thanks to @maennchen for the PR. Closes #6.","ref":"changelog.html#cldr-utils-version-2-19-2","title":"Changelog - Cldr Utils version 2.19.2","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.19.1 released on August 23rd, 2022. For older changelogs please consult the release tag on GitHub Cldr Utils now requires Elixir 1.11 or later Bug Fixes Use only TLS 1.2 on OTP versions less than 25.","ref":"changelog.html#cldr-utils-version-2-19-1","title":"Changelog - Cldr Utils version 2.19.1","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.19.0 released on August 22nd, 2022. For older changelogs please consult the release tag on GitHub Cldr Utils now requires Elixir 1.11 or later Enhancements Sets SNI option for SSL connections Supports CLDR_UNSAFE_HTTPS environment variable option which, if set to anything other than FALSE , false , nil or NIL will not perform peer verification for HTTPS requests. This may be used in circumstances where peer verification is failing but if generally not recommended.","ref":"changelog.html#cldr-utils-version-2-19-0","title":"Changelog - Cldr Utils version 2.19.0","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.18.0 released on July 31st, 2022. For older changelogs please consult the release tag on GitHub Cldr Utils now requires Elixir 1.11 or later Bug Fixes Fix deprecation warnings for Elixir 1.14.","ref":"changelog.html#cldr-utils-version-2-18-0","title":"Changelog - Cldr Utils version 2.18.0","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.17.2 released on May 8th, 2022. For older changelogs please consult the release tag on GitHub Bug Fixes Harden the SSL options for Cldr.Http.get/1 in line with the recommendations at https://erlef.github.io/security-wg/secure_coding_and_deployment_hardening/ssl","ref":"changelog.html#cldr-utils-version-2-17-2","title":"Changelog - Cldr Utils version 2.17.2","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.17.1 released on February 21st, 2022. For older changelogs please consult the release tag on GitHub Bug Fixes Fix Cldr.Map.invert/2 to use Enum.map/2 not Enum.flat_map/2","ref":"changelog.html#cldr-utils-version-2-17-1","title":"Changelog - Cldr Utils version 2.17.1","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.17.0 released on October 27th, 2021. For older changelogs please consult the release tag on GitHub Enhancements Add :duplicates option to Cldr.Map.invert/2 to determine how to handle duplicate values after inversion. The options are: nil or false which is the default and means only one value is kept. Map.new/1 is used meanng the selected value is non-deterministic. :keep meaning duplicate values are returned in a list :shortest means the shortest duplicate is kept. This operates on string or atom values. :longest means the shortest duplicate is kept. This operates on string or atom values. Bug Fixes Don't attempt to convert calendar era dates to iso days - do that when required in ex_cldr_calendars Remove Cldr.Calendar.Conversion module which is not required Fix Cldr.Map.deep_map/3 so that the :filter option is propogated correctly when :only/:except is also specified.","ref":"changelog.html#cldr-utils-version-2-17-0","title":"Changelog - Cldr Utils version 2.17.0","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.17.0 released on October 5th, 2021. For older changelogs please consult the release tag on GitHub Bug Fixes Don't attempt to convert calendar era dates to iso days - do that when required in ex_cldr_calendars Remove Cldr.Calendar.Conversion module which is not required Fix Cldr.Map.deep_map/3 so that the :filter option is propogated correctly when :only/:except is also specified. Enhancements Add :duplicates option to Cldr.Map.invert/2 to determine how to handle duplicate values after inversion. The options are: nil or false which is the default and means only one value is kept. Map.new/1 is used meanng the selected value is non-deterministic. :keep meaning duplicate values are returned in a list :shortest means the shortest duplicate is kept. This operates on string or atom values. :longest means the shortest duplicate is kept. This operates on string or atom values.","ref":"changelog.html#cldr-utils-version-2-17-0-rc-0","title":"Changelog - Cldr Utils version 2.17.0-rc.0","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.16.0 released on June 11th, 2021. For older changelogs please consult the release tag on GitHub Enhancements Add Cldr.Map.extract_strings/2 Make resolver a parameter to Cldr.Map.deep_merge/3 Make resolver a parameter to Cldr.Map.merge_map_list/2 Add Cldr.Map.prune/2 that prunes (deletes) branches from a (possibly deeply nested) map Add Cldr.Map.invert/1 that inverts the {key, value} of a map to be {value, key} and if value is a list, one new map entry for each element of value will be created (mapped to key )","ref":"changelog.html#cldr-utils-version-2-16-0","title":"Changelog - Cldr Utils version 2.16.0","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.15.1 released on March 16th, 2021. For older changelogs please consult the release tag on GitHub Bug Fixes Fix Cldr.Digit.to_number/2 for floats. Thanks for the report from @jlauemoeller. Fixes #15.","ref":"changelog.html#cldr-utils-version-2-15-1","title":"Changelog - Cldr Utils version 2.15.1","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.15.0 released on March 5th, 2021. For older changelogs please consult the release tag on GitHub Enhancements Adds the options :filter , :reject and :skip to Cldr.Map.deep_map/3 that work on entire branches of a map.","ref":"changelog.html#cldr-utils-version-2-15-0","title":"Changelog - Cldr Utils version 2.15.0","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.14.1 released on February 17th, 2021. For older changelogs please consult the release tag on GitHub Bug Fixes Merge the fixes from cldr_utils version 2.13.3 for Cldr.Math.power/2","ref":"changelog.html#cldr-utils-version-2-14-1","title":"Changelog - Cldr Utils version 2.14.1","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.14.0 released on November 7th, 2020. For older changelogs please consult the release tag on GitHub Enhancements Adds Cldr.Http.get/1 to download from https URLs using :httpc but with certificate vertification enabled (it is not enabled by default in the :httpc module).","ref":"changelog.html#cldr-utils-version-2-14-0","title":"Changelog - Cldr Utils version 2.14.0","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.13.3 released on February 17th, 2021. For older changelogs please consult the release tag on GitHub Bug fixes Fix Cldr.Math.power/2 when both arguments are Decimal and the power is negative. Update the docs for Cldr.Math.round_significant/2 to note that rounding floats to significant digits cannot always return the expected precision since floats cannot represent all decimal numbers correctly.","ref":"changelog.html#cldr-utils-version-2-13-3","title":"Changelog - Cldr Utils version 2.13.3","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.13.2 released on October 20th, 2020. For older changelogs please consult the release tag on GitHub Bug fixes Fix unused variable warning on OTP versions that do not include :persistent_term module. Thanks to @kianmeng.","ref":"changelog.html#cldr-utils-version-2-13-2","title":"Changelog - Cldr Utils version 2.13.2","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.13.1 released on September 30th, 2020. For older changelogs please consult the release tag on GitHub Enhancements Add Cldr.Decimal.parse/1 as a compatibiity layer for Decimal 1.x and 2.x","ref":"changelog.html#cldr-utils-version-2-13-1","title":"Changelog - Cldr Utils version 2.13.1","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.12.0 released on September 29th, 2020. For older changelogs please consult the release tag on GitHub Enhancements Add Cldr.Digit.number_of_trailing_zeros/1 to calculate the number of trailing zeros in an integer","ref":"changelog.html#cldr-utils-version-2-12-0","title":"Changelog - Cldr Utils version 2.12.0","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.11.0 released on September 25th, 2020. For older changelogs please consult the release tag on GitHub Enhancements Provides Cldr.Decimal.reduce/1 as a compatibility shim for Decimal 1.x and 2.x Provides Cldr.Decimal.compare/2 as a compatibility shim for Decimal 1.x and 2.x","ref":"changelog.html#cldr-utils-version-2-11-0","title":"Changelog - Cldr Utils version 2.11.0","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.10.0 released on September 8th, 2020. For older changelogs please consult the release tag on GitHub Enhancements Supports Decimal 1.6 or greater or Decimal 2.x or later","ref":"changelog.html#cldr-utils-version-2-10-0","title":"Changelog - Cldr Utils version 2.10.0","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.9.1 released on May 3rd, 2020. For older changelogs please consult the release tag on GitHub Bug Fixes Fix compatibility with ex_cldr releases up to 2.13.0. Thanks to @hl for the report. Fixes #3.","ref":"changelog.html#cldr-utils-version-2-9-1","title":"Changelog - Cldr Utils version 2.9.1","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.9.0 released on May 2nd, 2020. For older changelogs please consult the release tag on GitHub Enhancements Add :level , :only and :except options to Cldr.Map.deep_map/3 and refactor functions that use it Add Cldr.Enum.reduce_peeking/3 that is a simple reduce function that also passed the tail of the enum being reduced to enable a simple form of lookahead Refactor Cldr.Math.round/2 implementation for floating point numbers that improves efficiency by about 100% since it avoids round trip conversion to Decimal","ref":"changelog.html#cldr-utils-version-2-9-0","title":"Changelog - Cldr Utils version 2.9.0","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.8.0 released on February 14th, 2020. For older changelogs please consult the release tag on GitHub Enhancements Be more resilient of the availability of :persistent_term given that get/2 , get/1 and :persistent_term itself are available on different OTP releases. Thanks to @halostatue. Closes #2.","ref":"changelog.html#cldr-utils-version-2-8-0","title":"Changelog - Cldr Utils version 2.8.0","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.7.0 released on January 31st, 2020. For older changelogs please consult the release tag on GitHub Enhancements Add Cldr.String.to_underscore/1 that replaces &quot;-&quot; with &quot;_&quot;","ref":"changelog.html#cldr-utils-version-2-7-0","title":"Changelog - Cldr Utils version 2.7.0","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.6.0 released on January 21st, 2020. For older changelogs please consult the release tag on GitHub Enhancements Support Decimal versions ~&gt; 1.6 or 1.9 or 2.0 . Version 1.9 deprecates Decimal.compare/2 in favour of Decimal.cmp/2 . The upcoming Decimal version 2.0 deprecates Decimal.cmp/2 in favour of a new implementation of Decimal.compare/2 that conforms to Elixir norms and is required to support Enum.sort/2 correctly. This version of cldr_utils detects the relevant version and adapts accordingly at compile time.","ref":"changelog.html#cldr-utils-version-2-6-0","title":"Changelog - Cldr Utils version 2.6.0","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.5.0 released on October 22nd, 2019. For older changelogs please consult the release tag on GitHub Enhancements Add Cldr.Macros.warn_once/3 to log a warning, but only once for a given key","ref":"changelog.html#cldr-utils-version-2-5-0","title":"Changelog - Cldr Utils version 2.5.0","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.4.0 released on August 23rd, 2019. For older changelogs please consult the release tag on GitHub Enhancements Add Cldr.String.hash/1 to implement a polynomial rolling hash function","ref":"changelog.html#cldr-utils-version-2-4-0","title":"Changelog - Cldr Utils version 2.4.0","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.3.0 released on June 15th, 2019. For older changelogs please consult the release tag on GitHub Enhancements Adds doc_since/1 and calendar_impl/0 to support conditional compilation based upon Elixir versions","ref":"changelog.html#cldr-utils-version-2-3-0","title":"Changelog - Cldr Utils version 2.3.0","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.2.0 released on March 25th, 2019. For older changelogs please consult the release tag on GitHub Enhancements Add Cldr.Math.div_amod/2","ref":"changelog.html#cldr-utils-version-2-2-0","title":"Changelog - Cldr Utils version 2.2.0","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.1.0 released on March 10th, 2019. For older changelogs please consult the release tag on GitHub Bug Fixes Cldr.Map.integerize_keys/1 now properly processes negative integer keys. Minor version change to make it easier to peg versions in upstream packages.","ref":"changelog.html#cldr-utils-version-2-1-0","title":"Changelog - Cldr Utils version 2.1.0","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.0.4 released on Jnauary 3rd, 2018. For older changelogs please consult the release tag on GitHub Bug Fixes Fixes Cldr.Math.round/3 for floats when rounding is &gt; 0 digits","ref":"changelog.html#cldr-utils-version-2-0-5","title":"Changelog - Cldr Utils version 2.0.5","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.0.4 released on Decmber 15th, 2018. For older changelogs please consult the release tag on GitHub Bug Fixes Fixes Cldr.Math.round/3 to be compatible with Decimal.round/3 and Kernel.round/1","ref":"changelog.html#cldr-utils-version-2-0-4","title":"Changelog - Cldr Utils version 2.0.4","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.0.3 released on Decmber 8th, 2018. For older changelogs please consult the release tag on GitHub Bug Fixes Fixed an error in Cldr.Math.round/3 for Decimal numbers where the value being rounded is &lt; 1 but greater than 0 whereby the sign was being returned as true instead of 1 .","ref":"changelog.html#cldr-utils-version-2-0-3","title":"Changelog - Cldr Utils version 2.0.3","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.0.2 released on November 23rd, 2018. For older changelogs please consult the release tag on GitHub Enhancements Replace additional deprecated Decimal.new/1 with Decimal.from_float/1 where required","ref":"changelog.html#cldr-utils-version-2-0-2","title":"Changelog - Cldr Utils version 2.0.2","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.0.1 released on November 23rd, 2018. For older changelogs please consult the release tag on GitHub Enhancements Replace deprecated Decimal.new/1 with Decimal.from_float/1 where required","ref":"changelog.html#cldr-utils-version-2-0-1","title":"Changelog - Cldr Utils version 2.0.1","type":"extras"},{"doc":"This is the changelog for Cldr Utils v2.0.0 released on October 29th, 2018. For older changelogs please consult the release tag on GitHub Enhancements Initial release extracted from ex_cldr","ref":"changelog.html#cldr-utils-version-2-0-0","title":"Changelog - Cldr Utils version 2.0.0","type":"extras"},{"doc":"Copyright (c) 2017 Kip Cole Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http :// www . apache . org / licenses / LICENSE - 2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"License","type":"extras"},{"doc":"Utility functions extracted from Cldr . Map functions for deep mapping, deep merging, transforming keys Math functions including mod/2 that works on floored division Number functions for working with the number of digits, the fraction as an integer, ... String function for underscoring (converting CamelCase to snake case) Various macros","ref":"readme.html","title":"Cldr Utils","type":"extras"},{"doc":"The package can be installed by adding :cldr_utils to your list of dependencies in mix.exs : def deps do [ { :cldr_utils , &quot;~&gt; 2.0&quot; } ] end","ref":"readme.html#installation","title":"Cldr Utils - Installation","type":"extras"},{"doc":"To run the benchmark: $ mix run benchee/decimal.exs","ref":"readme.html#benchmark","title":"Cldr Utils - Benchmark","type":"extras"},{"doc":"Copyright (c) 2017 Kip Cole Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"readme.html#copyright-and-license","title":"Cldr Utils - Copyright and License","type":"extras"}]